'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function gcd(x, y) {
    return y === 0 ? x : gcd(y, x % y);
}
function gcdBigint(x, y) {
    return y === 0n ? x : gcdBigint(y, x % y);
}

function euclidean(a, b) {
    let x;
    let y;
    let d;
    solve(a, b);
    return [x, y, d];
    function solve(_a, _b) {
        if (_b === 0) {
            x = 1;
            y = 0;
            d = _a;
        }
        else {
            const A = _a % _b;
            const B = _b;
            solve(B, A);
            const X = y;
            const Y = x;
            x = X;
            y = Y - Math.floor(_a / _b) * X;
        }
    }
}
function euclideanBigint(a, b) {
    let x;
    let y;
    let d;
    solve(a, b);
    return [x, y, d];
    function solve(_a, _b) {
        if (_b === 0n) {
            x = 1n;
            y = 0n;
            d = _a;
        }
        else {
            const A = _a % _b;
            const B = _b;
            solve(B, A);
            const X = y;
            const Y = x;
            x = X;
            y = Y - (_a / _b) * X;
        }
    }
}

exports.euclidean = euclidean;
exports.euclideanBigint = euclideanBigint;
exports.gcd = gcd;
exports.gcdBigint = gcdBigint;
